"""
Constants used by android throughout the binder subsystem.
"""

EX_HAS_NOTED_APPOPS_REPLY_HEADER = -127
EX_HAS_STRICTMODE_REPLY_HEADER = -128
EX_TRANSACTION_FAILED = -129

EX_SECURITY = -1
EX_BAD_PARCELABLE = -2
EX_ILLEGAL_ARGUMENT = -3
EX_NULL_POINTER = -4
EX_ILLEGAL_STATE = -5
EX_NETWORK_MAIN_THREAD = -6
EX_UNSUPPORTED_OPERATION = -7
EX_SERVICE_SPECIFIC = -8
EX_PARCELABLE = -9

VAL_NULL = -1
VAL_STRING = 0
VAL_INTEGER = 1
VAL_MAP = 2
VAL_BUNDLE = 3
VAL_PARCELABLE = 4
VAL_SHORT = 5
VAL_LONG = 6
VAL_FLOAT = 7
VAL_DOUBLE = 8
VAL_BOOLEAN = 9
VAL_CHARSEQUENCE = 10
VAL_LIST = 11
VAL_SPARSEARRAY = 12
VAL_BYTEARRAY = 13
VAL_STRINGARRAY = 14
VAL_IBINDER = 15
VAL_PARCELABLEARRAY = 16
VAL_OBJECTARRAY = 17
VAL_INTARRAY = 18
VAL_LONGARRAY = 19
VAL_BYTE = 20
VAL_SERIALIZABLE = 21
VAL_SPARSEBOOLEANARRAY = 22
VAL_BOOLEANARRAY = 23
VAL_CHARSEQUENCEARRAY = 24
VAL_PERSISTABLEBUNDLE = 25
VAL_SIZE = 26
VAL_SIZEF = 27
VAL_DOUBLEARRAY = 28
VAL_CHAR = 29
VAL_SHORTARRAY = 30
VAL_CHARARRAY = 31
VAL_FLOATARRAY = 32

BUNDLE_MAGIC = 0x4C444E42  # "BNDL"
BUNDLE_MAGIC_NATIVE = 0x4C444E44  # "BNDN"

URI_NULL_TYPE_ID = 0
URI_STRING_TYPE_ID = 1
URI_OPAQUE_TYPE_ID = 2
URI_HIERARCHICAL_TYPE_ID = 3


class BlobType:
    """
    Represents the type of Blob used in Parcel.readBlob
    We can't access ashmem from here, so the only one that really matters is BLOB_INPLACE
    """

    BLOB_INPLACE = 0
    BLOB_ASHMEM_IMMUTABLE = 1
    BLOB_ASHMEM_MUTABLE = 2


class SpanType:
    """
    Represents the type of span in a CharSequence.
    New span types must be added here and implemented in the override for TextUtils / CharSequence in overrides.py
    """

    ALIGNMENT_SPAN = 1
    FIRST_SPAN = ALIGNMENT_SPAN
    FOREGROUND_COLOR_SPAN = 2
    RELATIVE_SIZE_SPAN = 3
    SCALE_X_SPAN = 4
    STRIKETHROUGH_SPAN = 5
    UNDERLINE_SPAN = 6
    STYLE_SPAN = 7
    BULLET_SPAN = 8
    QUOTE_SPAN = 9
    LEADING_MARGIN_SPAN = 10
    URL_SPAN = 11
    BACKGROUND_COLOR_SPAN = 12
    TYPEFACE_SPAN = 13
    SUPERSCRIPT_SPAN = 14
    SUBSCRIPT_SPAN = 15
    ABSOLUTE_SIZE_SPAN = 16
    TEXT_APPEARANCE_SPAN = 17
    ANNOTATION = 18
    SUGGESTION_SPAN = 19
    SPELL_CHECK_SPAN = 20
    SUGGESTION_RANGE_SPAN = 21
    EASY_EDIT_SPAN = 22
    LOCALE_SPAN = 23
    TTS_SPAN = 24
    ACCESSIBILITY_CLICKABLE_SPAN = 25
    ACCESSIBILITY_URL_SPAN = 26
    LINE_BACKGROUND_SPAN = 27
    LINE_HEIGHT_SPAN = 28
    ACCESSIBILITY_REPLACEMENT_SPAN = 29
    LAST_SPAN = ACCESSIBILITY_REPLACEMENT_SPAN
